Index: /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 107)
@@ -1480,130 +1191,238 @@
 }
 
-/*
- * Forcely terminate transaction.
- */
-PJ_DEF(void) pjsip_tsx_terminate( pjsip_transaction *tsx, int code )
-{
+
+/* Callback called by send message framework */
+static void send_msg_callback( pjsip_send_state *send_state,
+			       pj_ssize_t sent, pj_bool_t *cont )
+{
+    pjsip_transaction *tsx = send_state->token;
     struct tsx_lock_data lck;
 
     lock_tsx(tsx, &lck);
-    tsx->status_code = code;
-    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
-                   PJSIP_EVENT_USER, NULL);
+
+    if (sent > 0) {
+	/* Successfully sent! */
+	pj_assert(send_state->cur_transport != NULL);
+
+	if (tsx->transport != send_state->cur_transport) {
+	    if (tsx->transport) {
+		pjsip_transport_dec_ref(tsx->transport);
+		tsx->transport = NULL;
+	    }
+	    tsx->transport = send_state->cur_transport;
+	    pjsip_transport_add_ref(tsx->transport);
+	}
+
+	/* Clear pending transport flag. */
+	tsx->transport_flag &= ~(TSX_HAS_PENDING_TRANSPORT);
+
+	/* Pending destroy? */
+	if (tsx->transport_flag & TSX_HAS_PENDING_DESTROY) {
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_DESTROYED, 
+			   PJSIP_EVENT_UNKNOWN, NULL );
+	    unlock_tsx(tsx, &lck);
+	    return;
+	}
+
+	/* Need to transmit a message? */
+	if (tsx->transport_flag & TSX_HAS_PENDING_SEND) {
+	    tsx->transport_flag &= ~(TSX_HAS_PENDING_SEND);
+	    tsx_send_msg(tsx, tsx->last_tx);
+	}
+
+	/* Need to reschedule retransmission? */
+	if (tsx->transport_flag & TSX_HAS_PENDING_RESCHED) {
+	    tsx->transport_flag &= ~(TSX_HAS_PENDING_RESCHED);
+	    tsx_resched_retransmission(tsx);
+	}
+
+    } else {
+	/* Failed to send! */
+	pj_assert(sent != 0);
+
+	/* If transaction is using the same transport as the failed one, 
+	 * release the transport.
+	 */
+	if (send_state->cur_transport==tsx->transport &&
+	    tsx->transport != NULL)
+	{
+	    pjsip_transport_dec_ref(tsx->transport);
+	    tsx->transport = NULL;
+	}
+
+	if (!*cont) {
+	    PJ_LOG(4,(tsx->obj_name, "Failed to send message! status=%d",
+		      -sent));
+
+	    /* Clear pending transport flag. */
+	    tsx->transport_flag &= ~(TSX_HAS_PENDING_TRANSPORT);
+
+	    /* Terminate transaction. */
+	    tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+			   PJSIP_EVENT_TRANSPORT_ERROR, send_state->tdata );
+	}
+    }
 
     unlock_tsx(tsx, &lck);
 }
 
-/*
- * Transport send completion callback.
- */
-static void tsx_on_send_complete(void *token, pjsip_tx_data *tdata,
-				 pj_ssize_t bytes_sent)
-{
-    PJ_UNUSED_ARG(token);
-    PJ_UNUSED_ARG(tdata);
-
-    if (bytes_sent <= 0) {
-	PJ_TODO(HANDLE_TRANSPORT_ERROR);
-    }
+
+/* Transport callback. */
+static void transport_callback(void *token, pjsip_tx_data *tdata,
+			       pj_ssize_t sent)
+{
+    if (sent < 0) {
+	pjsip_transaction *tsx = token;
+	struct tsx_lock_data lck;
+
+	PJ_LOG(4,(tsx->obj_name, "Failed to send message! status=%d",
+		  -sent));
+
+	lock_tsx(tsx, &lck);
+
+	/* Dereference transport. */
+	pjsip_transport_dec_ref(tsx->transport);
+	tsx->transport = NULL;
+
+	/* Terminate transaction. */
+	tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+		       PJSIP_EVENT_TRANSPORT_ERROR, tdata );
+
+	unlock_tsx(tsx, &lck);
+   }
 }
 
 /*
  * Send message to the transport.
- * If transport is not yet available, then do nothing. The message will be
- * transmitted when transport connection completion callback is called.
  */
 static pj_status_t tsx_send_msg( pjsip_transaction *tsx, 
                                  pjsip_tx_data *tdata)
 {
-    pj_status_t status = PJ_SUCCESS;
-
-    PJ_LOG(5,(tsx->obj_name, "sending msg (tdata=%p)", tdata));
-
-    if (tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL) {
-	pjsip_event before_tx_event;
-
-	pj_assert(tsx->transport != NULL);
-
-	/* Make sure Via transport info is filled up properly for
-	 * requests. 
+    pj_status_t status = PJ_EBUG;
+
+    PJ_ASSERT_RETURN(tsx && tdata, PJ_EINVAL);
+
+    /* Send later if transport is still pending. */
+    if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+	tsx->transport_flag |= TSX_HAS_PENDING_SEND;
+	return PJ_SUCCESS;
+    }
+
+    if (tdata->msg->type == PJSIP_REQUEST_MSG) {
+	/* If we have the transport, send the message using that transport.
+	 * Otherwise perform full transport resolution.
 	 */
-	if (tdata->msg->type == PJSIP_REQUEST_MSG) {
-	    pjsip_via_hdr *via = (pjsip_via_hdr*) 
-		pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
-
-	    /* For request message, set "rport" parameter by default. */
-	    if (tdata->msg->type == PJSIP_REQUEST_MSG)
-		via->rport_param = 0;
-
-	    /* Don't update Via sent-by on retransmission. */
-	    if (via->sent_by.host.slen == 0) {
-		pj_strdup2(tdata->pool, &via->transport, 
-			   tsx->transport->type_name);
-		pj_strdup(tdata->pool, &via->sent_by.host, 
-			  &tsx->transport->local_name.host);
-		via->sent_by.port = tsx->transport->local_name.port;
+	if (tsx->transport) {
+	    status = pjsip_transport_send( tsx->transport, tdata, &tsx->addr,
+					   tsx->addr_len, tsx, 
+					   &transport_callback);
+	    if (status == PJ_EPENDING)
+		status = PJ_SUCCESS;
+
+	    if (status != PJ_SUCCESS) {
+		/* On error, release transport to force using full transport
+		 * resolution procedure.
+		 */
+		if (tsx->transport) {
+		    pjsip_transport_dec_ref(tsx->transport);
+		    tsx->transport = NULL;
+		}
+		tsx->addr_len = 0;
 	    }
 	}
-
-	/* Notify everybody we're about to send message. */
-        PJSIP_EVENT_INIT_PRE_TX_MSG(before_tx_event, tsx, tdata, 
-                                    tsx->retransmit_count);
-	pjsip_endpt_send_tsx_event( tsx->endpt, &before_tx_event );
-
-	tsx->has_unsent_msg = 0;
-	status = pjsip_transport_send(tsx->transport, tdata,
-			&tsx->remote_addr.entry[tsx->current_addr].addr,
-			tsx->remote_addr.entry[tsx->current_addr].addr_len,
-			tsx, &tsx_on_send_complete);
-	if (status != PJ_SUCCESS && status != PJ_EPENDING) {
-	    PJ_TODO(HANDLE_TRANSPORT_ERROR);
-	    goto on_error;
-	}
+	
+	if (!tsx->transport) {
+	    tsx->transport_flag |= TSX_HAS_PENDING_TRANSPORT;
+	    status = pjsip_endpt_send_request_stateless(tsx->endpt, tdata, tsx,
+							&send_msg_callback);
+	    if (status == PJ_EPENDING)
+		status = PJ_SUCCESS;
+	}
+
     } else {
-	tsx->has_unsent_msg = 1;
-    }
-
-    return 0;
-
-on_error:
-    tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
-                   PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
+	/* If we have the transport, send the message using that transport.
+	 * Otherwise perform full transport resolution.
+	 */
+	if (tsx->transport) {
+	    status = pjsip_transport_send( tsx->transport, tdata, 
+					   &tsx->addr, tsx->addr_len,
+					   tsx, &transport_callback);
+	    if (status == PJ_EPENDING)
+		status = PJ_SUCCESS;
+
+	    if (status != PJ_SUCCESS) {
+		if (tsx->transport) {
+		    pjsip_transport_dec_ref(tsx->transport);
+		    tsx->transport = NULL;
+		}
+		tsx->addr_len = 0;
+		tsx->res_addr.transport = NULL;
+		tsx->res_addr.addr_len = 0;
+	    }
+
+	} 
+
+	if (!tsx->transport) {
+	    tsx->transport_flag |= TSX_HAS_PENDING_TRANSPORT;
+	    status = pjsip_endpt_send_response( tsx->endpt, &tsx->res_addr, 
+						tdata, tsx, 
+						&send_msg_callback);
+	    if (status == PJ_EPENDING)
+		status = PJ_SUCCESS;
+	}
+    }
+
     return status;
 }
 
+
 /*
  * Retransmit last message sent.
  */
-static pj_status_t pjsip_tsx_retransmit( pjsip_transaction *tsx,
-					 int should_restart_timer)
+static void tsx_resched_retransmission( pjsip_transaction *tsx )
+{
+    pj_time_val timeout;
+    int msec_time;
+
+    pj_assert((tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) == 0);
+
+    msec_time = (1 << (tsx->retransmit_count)) * PJSIP_T1_TIMEOUT;
+
+    if (msec_time>PJSIP_T2_TIMEOUT && tsx->method.id!=PJSIP_INVITE_METHOD)
+	msec_time = PJSIP_T2_TIMEOUT;
+
+    timeout.sec = msec_time / 1000;
+    timeout.msec = msec_time % 1000;
+    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->retransmit_timer, 
+				&timeout);
+}
+
+/*
+ * Retransmit last message sent.
+ */
+static pj_status_t tsx_retransmit( pjsip_transaction *tsx, int resched)
 {
     pj_status_t status;
 
+    PJ_ASSERT_RETURN(tsx->last_tx!=NULL, PJ_EBUG);
+
     PJ_LOG(4,(tsx->obj_name, "retransmiting (tdata=%p, count=%d, restart?=%d)", 
-	      tsx->last_tx, tsx->retransmit_count, should_restart_timer));
-
-    pj_assert(tsx->last_tx != NULL);
+	      tsx->last_tx, tsx->retransmit_count, resched));
 
     ++tsx->retransmit_count;
 
     status = tsx_send_msg( tsx, tsx->last_tx);
-    if (status != PJ_SUCCESS) {
+    if (status != PJ_SUCCESS)
 	return status;
-    }
     
     /* Restart timer T1. */
-    if (should_restart_timer) {
-	pj_time_val timeout;
-	int msec_time = (1 << (tsx->retransmit_count)) * PJSIP_T1_TIMEOUT;
-
-	if (tsx->method.id!=PJSIP_INVITE_METHOD && msec_time>PJSIP_T2_TIMEOUT) 
-	    msec_time = PJSIP_T2_TIMEOUT;
-
-	timeout.sec = msec_time / 1000;
-	timeout.msec = msec_time % 1000;
-	pjsip_endpt_schedule_timer( tsx->endpt, &tsx->retransmit_timer, 
-				    &timeout);
+    if (resched) {
+	if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+	    tsx->transport_flag |= TSX_HAS_PENDING_RESCHED;
+	} else {
+	    tsx_resched_retransmission(tsx);
+	}
     }
 
@@ -1611,29 +1430,41 @@
 }
 
+
 /*
  * Handler for events in state Null.
  */
-static pj_status_t pjsip_tsx_on_state_null( pjsip_transaction *tsx, 
-                                            pjsip_event *event )
+static pj_status_t tsx_on_state_null( pjsip_transaction *tsx, 
+                                      pjsip_event *event )
 {
     pj_status_t status;
 
-    pj_assert( tsx->state == PJSIP_TSX_STATE_NULL);
-    pj_assert( tsx->last_tx == NULL );
-    pj_assert( tsx->has_unsent_msg == 0);
+    pj_assert(tsx->state == PJSIP_TSX_STATE_NULL);
 
     if (tsx->role == PJSIP_ROLE_UAS) {
 
-	/* Set state to Trying. */
-	pj_assert(event->type == PJSIP_EVENT_RX_MSG);
-	tsx_set_state( tsx, PJSIP_TSX_STATE_TRYING, 
-                       PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
+	/* UAS doesn't have STATE_NULL.
+	 * State has moved from NULL after transaction is initialized.
+	 */
+	pj_assert(!"Bug bug bug!!");
+	return PJ_EBUG;
 
     } else {
-	pjsip_tx_data *tdata = event->body.tx_msg.tdata;
+	pjsip_tx_data *tdata;
+
+	/* Must be transmit event. */
+	PJ_ASSERT_RETURN(event->type == PJSIP_EVENT_TX_MSG, PJ_EBUG);
+
+	/* Get the txdata */
+	tdata = event->body.tx_msg.tdata;
 
 	/* Save the message for retransmission. */
-	tsx->last_tx = tdata;
-	pjsip_tx_data_add_ref(tdata);
+	if (tsx->last_tx && tsx->last_tx != tdata) {
+	    pjsip_tx_data_dec_ref(tsx->last_tx);
+	    tsx->last_tx = NULL;
+	}
+	if (tsx->last_tx != tdata) {
+	    tsx->last_tx = tdata;
+	    pjsip_tx_data_add_ref(tdata);
+	}
 
 	/* Send the message. */
@@ -1652,10 +1483,12 @@
 	 * transport is being used.
 	 */
-	if (tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL &&
-	    PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0) 
-	{
-	    pjsip_endpt_schedule_timer(tsx->endpt, &tsx->retransmit_timer, 
-                                       &t1_timer_val);
+	if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport))  {
 	    tsx->retransmit_count = 0;
+	    if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+		tsx->transport_flag |= TSX_HAS_PENDING_RESCHED;
+	    } else {
+		pjsip_endpt_schedule_timer(tsx->endpt, &tsx->retransmit_timer,
+					   &t1_timer_val);
+	    }
 	}
 
@@ -1668,10 +1501,11 @@
 }
 
+
 /*
  * State Calling is for UAC after it sends request but before any responses
  * is received.
  */
-static pj_status_t pjsip_tsx_on_state_calling( pjsip_transaction *tsx, 
-				               pjsip_event *event )
+static pj_status_t tsx_on_state_calling( pjsip_transaction *tsx, 
+				         pjsip_event *event )
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_CALLING);
@@ -1684,5 +1518,5 @@
 
 	/* Retransmit the request. */
-        status = pjsip_tsx_retransmit( tsx, 1 );
+        status = tsx_retransmit( tsx, 1 );
 	if (status != PJ_SUCCESS) {
 	    return status;
@@ -1706,8 +1540,16 @@
 
 	/* Transaction is destroyed */
-	return PJSIP_ETSXDESTROYED;
+	//return PJSIP_ETSXDESTROYED;
 
     } else if (event->type == PJSIP_EVENT_RX_MSG) {
-	int code;
+	pjsip_msg *msg;
+	//int code;
+
+	/* Get message instance */
+	msg = event->body.rx_msg.rdata->msg_info.msg;
+
+	/* Better be a response message. */
+	if (msg->type != PJSIP_RESPONSE_MSG)
+	    return PJSIP_ENOTRESPONSEMSG;
 
 	/* Cancel retransmission timer A. */
@@ -1723,15 +1565,16 @@
 	 */
 	/* Keep last_tx for authorization. */
-	code = event->body.rx_msg.rdata->msg_info.msg->line.status.code;
-	if (tsx->method.id != PJSIP_INVITE_METHOD && code!=401 && code!=407) {
-	    pjsip_tx_data_dec_ref(tsx->last_tx);
-	    tsx->last_tx = NULL;
-	}
+	//blp: always keep last_tx until transaction is destroyed
+	//code = msg->line.status.code;
+	//if (tsx->method.id != PJSIP_INVITE_METHOD && code!=401 && code!=407) {
+	//    pjsip_tx_data_dec_ref(tsx->last_tx);
+	//    tsx->last_tx = NULL;
+	//}
 
 	/* Processing is similar to state Proceeding. */
-	pjsip_tsx_on_state_proceeding_uac( tsx, event);
+	tsx_on_state_proceeding_uac( tsx, event);
 
     } else {
-	pj_assert(0);
+	pj_assert(!"Unexpected event");
         return PJ_EBUG;
     }
@@ -1739,4 +1582,5 @@
     return PJ_SUCCESS;
 }
+
 
 /*
@@ -1746,6 +1590,6 @@
  *	 non-INVITE client transaction (bug in RFC?).
  */
-static pj_status_t pjsip_tsx_on_state_trying( pjsip_transaction *tsx, 
-                                              pjsip_event *event)
+static pj_status_t tsx_on_state_trying( pjsip_transaction *tsx, 
+                                        pjsip_event *event)
 {
     pj_status_t status;
@@ -1762,5 +1606,4 @@
      * response because we haven't sent any!).
      */
-    //pj_assert(event->type == PJSIP_EVENT_TX_MSG);
     if (event->type != PJSIP_EVENT_TX_MSG) {
 	return PJ_SUCCESS;
@@ -1770,14 +1613,17 @@
      * "Proceeding" state.
      */
-    status = pjsip_tsx_on_state_proceeding_uas( tsx, event);
+    status = tsx_on_state_proceeding_uas( tsx, event);
 
     /* Inform the TU of the state transision if state is still State_Trying */
     if (status==PJ_SUCCESS && tsx->state == PJSIP_TSX_STATE_TRYING) {
+
 	tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, 
                        PJSIP_EVENT_TX_MSG, event->body.tx_msg.tdata);
+
     }
 
     return status;
 }
+
 
 /*
@@ -1785,6 +1631,6 @@
  * This state happens after the TU sends provisional response.
  */
-static pj_status_t pjsip_tsx_on_state_proceeding_uas( pjsip_transaction *tsx,
-                                                      pjsip_event *event)
+static pj_status_t tsx_on_state_proceeding_uas( pjsip_transaction *tsx,
+                                                pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_PROCEEDING || 
@@ -1799,8 +1645,14 @@
         pj_status_t status;
 
-	/* Send last response. */
-        status = pjsip_tsx_retransmit( tsx, 0 );
-	if (status != PJ_SUCCESS) {
-	    return status;
+	/* Must have last response sent. */
+	PJ_ASSERT_RETURN(tsx->last_tx != NULL, PJ_EBUG);
+
+	/* Send last response */
+	if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+	    tsx->transport_flag |= TSX_HAS_PENDING_SEND;
+	} else {
+	    status = tsx_send_msg(tsx, tsx->last_tx);
+	    if (status != PJ_SUCCESS)
+		return status;
 	}
 	
@@ -1816,8 +1668,5 @@
 
 	/* This can only be a response message. */
-	pj_assert(msg->type == PJSIP_RESPONSE_MSG);
-
-	/* Status code must be higher than last sent. */
-	pj_assert(msg->line.status.code >= tsx->status_code);
+	PJ_ASSERT_RETURN(msg->type==PJSIP_RESPONSE_MSG, PJSIP_ENOTRESPONSEMSG);
 
 	/* Update last status */
@@ -1848,4 +1697,5 @@
 		pjsip_tx_data_add_ref( tdata );
 	    }
+
 	    tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, 
                            PJSIP_EVENT_TX_MSG, tdata );
@@ -1853,5 +1703,5 @@
 	} else if (PJSIP_IS_STATUS_IN_CLASS(tsx->status_code, 200)) {
 
-	    if (tsx->method.id == PJSIP_INVITE_METHOD && tsx->handle_ack==0) {
+	    if (tsx->method.id == PJSIP_INVITE_METHOD && tsx->handle_200resp==0) {
 
 		/* 2xx class message is not saved, because retransmission 
@@ -1862,5 +1712,5 @@
 
 		/* Transaction is destroyed. */
-		return PJSIP_ETSXDESTROYED;
+		//return PJSIP_ETSXDESTROYED;
 
 	    } else {
@@ -1869,7 +1719,11 @@
 		if (tsx->method.id == PJSIP_INVITE_METHOD) {
 		    tsx->retransmit_count = 0;
-		    pjsip_endpt_schedule_timer( tsx->endpt, 
-                                                &tsx->retransmit_timer, 
-						&t1_timer_val);
+		    if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+			tsx->transport_flag |= TSX_HAS_PENDING_RESCHED;
+		    } else {
+			pjsip_endpt_schedule_timer( tsx->endpt, 
+						    &tsx->retransmit_timer,
+						    &t1_timer_val);
+		    }
 		}
 
@@ -1885,5 +1739,5 @@
 		 * reliable transport.
 		 */
-		if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0) {
+		if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)) {
 		    timeout = timeout_timer_val;
 		} else {
@@ -1916,12 +1770,16 @@
 	     * timer G will be scheduled (retransmission).
 	     */
-	    if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0) {
+	    if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)) {
 		pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ,
                                                            NULL);
 		if (cseq->method.id == PJSIP_INVITE_METHOD) {
 		    tsx->retransmit_count = 0;
-		    pjsip_endpt_schedule_timer(tsx->endpt, 
-                                               &tsx->retransmit_timer, 
-					       &t1_timer_val);
+		    if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+			tsx->transport_flag |= TSX_HAS_PENDING_RESCHED;
+		    } else {
+			pjsip_endpt_schedule_timer(tsx->endpt, 
+						   &tsx->retransmit_timer, 
+						   &t1_timer_val);
+		    }
 		}
 	    }
@@ -1938,12 +1796,16 @@
     } else if (event->type == PJSIP_EVENT_TIMER && 
 	       event->body.timer.entry == &tsx->retransmit_timer) {
+
 	/* Retransmission timer elapsed. */
         pj_status_t status;
 
+	/* Must not be triggered while transport is pending. */
+	pj_assert((tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) == 0);
+
 	/* Must have last response to retransmit. */
 	pj_assert(tsx->last_tx != NULL);
 
 	/* Retransmit the last response. */
-        status = pjsip_tsx_retransmit( tsx, 1 );
+        status = tsx_retransmit( tsx, 1 );
 	if (status != PJ_SUCCESS) {
 	    return status;
@@ -1954,5 +1816,5 @@
 
 	/* Timeout timer. should not happen? */
-	pj_assert(0);
+	pj_assert(!"Should not happen(?)");
 
 	tsx->status_code = PJSIP_SC_TSX_TIMEOUT;
@@ -1964,5 +1826,5 @@
 
     } else {
-	pj_assert(0);
+	pj_assert(!"Unexpected event");
         return PJ_EBUG;
     }
@@ -1970,4 +1832,5 @@
     return PJ_SUCCESS;
 }
+
 
 /*
@@ -1976,6 +1839,6 @@
  * UAS.
  */
-static pj_status_t pjsip_tsx_on_state_proceeding_uac(pjsip_transaction *tsx, 
-                                                     pjsip_event *event)
+static pj_status_t tsx_on_state_proceeding_uac(pjsip_transaction *tsx, 
+                                               pjsip_event *event)
 {
 
@@ -1984,4 +1847,6 @@
 
     if (event->type != PJSIP_EVENT_TIMER) {
+	pjsip_msg *msg;
+
 	/* Must be incoming response, because we should not retransmit
 	 * request once response has been received.
@@ -1992,5 +1857,13 @@
 	}
 
-	tsx->status_code = event->body.rx_msg.rdata->msg_info.msg->line.status.code;
+	msg = event->body.rx_msg.rdata->msg_info.msg;
+
+	/* Must be a response message. */
+	if (msg->type != PJSIP_RESPONSE_MSG) {
+	    pj_assert(!"Expecting response message!");
+	    return PJSIP_ENOTRESPONSEMSG;
+	}
+
+	tsx->status_code = msg->line.status.code;
     } else {
 	tsx->status_code = PJSIP_SC_TSX_TIMEOUT;
@@ -2011,8 +1884,8 @@
 	 * handled in TU). For non-INVITE, state moves to Completed.
 	 */
-	if (tsx->method.id == PJSIP_INVITE_METHOD && tsx->handle_ack == 0) {
+	if (tsx->method.id == PJSIP_INVITE_METHOD) {
 	    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
                            PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
-	    return PJSIP_ETSXDESTROYED;
+	    //return PJSIP_ETSXDESTROYED;
 
 	} else {
@@ -2047,6 +1920,17 @@
 	/* Generate and send ACK for INVITE. */
 	if (tsx->method.id == PJSIP_INVITE_METHOD) {
-	    pjsip_endpt_create_ack( tsx->endpt, tsx->last_tx, 
-                                    event->body.rx_msg.rdata );
+	    pjsip_tx_data *ack;
+
+	    status = pjsip_endpt_create_ack( tsx->endpt, tsx->last_tx, 
+					     event->body.rx_msg.rdata,
+					     &ack);
+	    if (status != PJ_SUCCESS)
+		return status;
+
+	    if (ack != tsx->last_tx) {
+		pjsip_tx_data_dec_ref(tsx->last_tx);
+		tsx->last_tx = ack;
+	    }
+
             status = tsx_send_msg( tsx, tsx->last_tx);
 	    if (status != PJ_SUCCESS) {
@@ -2056,5 +1940,5 @@
 
 	/* Start Timer D with TD/T4 timer if unreliable transport is used. */
-	if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport) == 0) {
+	if (!PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)) {
 	    if (tsx->method.id == PJSIP_INVITE_METHOD) {
 		timeout = td_timer_val;
@@ -2073,5 +1957,5 @@
     } else {
 	// Shouldn't happen because there's no timer for this state.
-	pj_assert(0);
+	pj_assert(!"Unexpected event");
         return PJ_EBUG;
     }
@@ -2080,9 +1964,10 @@
 }
 
+
 /*
  * Handler for events in Completed state for UAS
  */
-static pj_status_t pjsip_tsx_on_state_completed_uas( pjsip_transaction *tsx, 
-                                                     pjsip_event *event)
+static pj_status_t tsx_on_state_completed_uas( pjsip_transaction *tsx, 
+                                               pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_COMPLETED);
@@ -2090,11 +1975,14 @@
     if (event->type == PJSIP_EVENT_RX_MSG) {
 	pjsip_msg *msg = event->body.rx_msg.rdata->msg_info.msg;
-	pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ, NULL );
+
+	/* This must be a request message retransmission. */
+	if (msg->type != PJSIP_REQUEST_MSG)
+	    return PJSIP_ENOTREQUESTMSG;
 
 	/* On receive request retransmission, retransmit last response. */
-	if (cseq->method.id != PJSIP_ACK_METHOD) {
+	if (msg->line.req.method.id != PJSIP_ACK_METHOD) {
             pj_status_t status;
 
-            status = pjsip_tsx_retransmit( tsx, 0 );
+            status = tsx_retransmit( tsx, 0 );
 	    if (status != PJ_SUCCESS) {
 		return status;
@@ -2123,5 +2011,5 @@
             pj_status_t status;
 
-            status = pjsip_tsx_retransmit( tsx, 1 );
+            status = tsx_retransmit( tsx, 1 );
 	    if (status != PJ_SUCCESS) {
 		return status;
@@ -2140,5 +2028,5 @@
                                PJSIP_EVENT_TIMER, &tsx->timeout_timer );
 
-		return PJSIP_ETSXDESTROYED;
+		//return PJSIP_ETSXDESTROYED;
 
 	    } else {
@@ -2146,5 +2034,5 @@
 		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
                                PJSIP_EVENT_TIMER, &tsx->timeout_timer );
-		return PJSIP_ETSXDESTROYED;
+		//return PJSIP_ETSXDESTROYED;
 	    }
 	}
@@ -2152,5 +2040,7 @@
     } else {
 	/* Ignore request to transmit. */
-	pj_assert(event->body.tx_msg.tdata == tsx->last_tx);
+	PJ_ASSERT_RETURN(event->type == PJSIP_EVENT_TX_MSG && 
+			 event->body.tx_msg.tdata == tsx->last_tx, 
+			 PJ_EINVALIDOP);
     }
 
@@ -2158,9 +2048,10 @@
 }
 
+
 /*
  * Handler for events in Completed state for UAC transaction.
  */
-static pj_status_t pjsip_tsx_on_state_completed_uac( pjsip_transaction *tsx,
-                                                     pjsip_event *event)
+static pj_status_t tsx_on_state_completed_uac( pjsip_transaction *tsx,
+                                               pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_COMPLETED);
@@ -2175,5 +2066,5 @@
 
 	/* Transaction has been destroyed. */
-	return PJSIP_ETSXDESTROYED;
+	//return PJSIP_ETSXDESTROYED;
 
     } else if (event->type == PJSIP_EVENT_RX_MSG) {
@@ -2189,5 +2080,5 @@
                 pj_status_t status;
 
-                status = pjsip_tsx_retransmit( tsx, 0 );
+                status = tsx_retransmit( tsx, 0 );
 		if (status != PJ_SUCCESS) {
 		    return status;
@@ -2200,31 +2091,8 @@
 	    /* Just drop the response. */
 	}
-    } else if (tsx->method.id == PJSIP_INVITE_METHOD &&
-	       event->type == PJSIP_EVENT_TX_MSG &&
-	       event->body.tx_msg.tdata->msg->line.req.method.id==PJSIP_ACK_METHOD) {
-
-        pj_status_t status;
-
-	/* Set last transmitted message. */
-	if (tsx->last_tx != event->body.tx_msg.tdata) {
-	    pjsip_tx_data_dec_ref( tsx->last_tx );
-	    tsx->last_tx = event->body.tx_msg.tdata;
-	    pjsip_tx_data_add_ref( tsx->last_tx );
-	}
-
-	/* No state changed, but notify app. 
-	 * Must notify now, so app has chance to put SDP in outgoing ACK msg.
-	 */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, 
-                       PJSIP_EVENT_TX_MSG, event->body.tx_msg.tdata );
-
-	/* Send msg */
-	status = tsx_send_msg(tsx, event->body.tx_msg.tdata);
-        if (status != PJ_SUCCESS)
-            return status;
 
     } else {
-	pj_assert(0);
-        return PJ_EBUG;
+	pj_assert(!"Unexpected event");
+        return PJ_EINVALIDOP;
     }
 
@@ -2232,9 +2100,10 @@
 }
 
+
 /*
  * Handler for events in state Confirmed.
  */
-static pj_status_t pjsip_tsx_on_state_confirmed( pjsip_transaction *tsx,
-                                                 pjsip_event *event)
+static pj_status_t tsx_on_state_confirmed( pjsip_transaction *tsx,
+                                           pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_CONFIRMED);
@@ -2247,18 +2116,13 @@
     if (event->type == PJSIP_EVENT_RX_MSG) {
 
-        pjsip_method_e method_id = 
-            event->body.rx_msg.rdata->msg_info.msg->line.req.method.id;
-
-	/* Must be a request message. */
-	pj_assert(event->body.rx_msg.rdata->msg_info.msg->type == PJSIP_REQUEST_MSG);
+	pjsip_msg *msg = event->body.rx_msg.rdata->msg_info.msg;
+
+	/* Only expecting request message. */
+	if (msg->type != PJSIP_REQUEST_MSG)
+	    return PJSIP_ENOTREQUESTMSG;
 
 	/* Must be an ACK request or a late INVITE retransmission. */
-	pj_assert(method_id == PJSIP_ACK_METHOD ||
-		  method_id == PJSIP_INVITE_METHOD);
-
-        /* Just so that compiler won't complain about unused vars when
-         * building release code.
-         */
-        PJ_UNUSED_ARG(method_id);
+	pj_assert(msg->line.req.method.id == PJSIP_ACK_METHOD || 
+		  msg->line.req.method.id == PJSIP_INVITE_METHOD);
 
     } else if (event->type == PJSIP_EVENT_TIMER) {
@@ -2271,8 +2135,8 @@
 
 	/* Transaction has been destroyed. */
-	return PJSIP_ETSXDESTROYED;
+	//return PJSIP_ETSXDESTROYED;
 
     } else {
-	pj_assert(0);
+	pj_assert(!"Unexpected event");
         return PJ_EBUG;
     }
@@ -2281,13 +2145,13 @@
 }
 
+
 /*
  * Handler for events in state Terminated.
  */
-static pj_status_t pjsip_tsx_on_state_terminated( pjsip_transaction *tsx,
-                                                  pjsip_event *event)
+static pj_status_t tsx_on_state_terminated( pjsip_transaction *tsx,
+                                            pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_TERMINATED);
-
-    PJ_UNUSED_ARG(event);
+    pj_assert(event->type == PJSIP_EVENT_TIMER);
 
     /* Destroy this transaction */
@@ -2299,10 +2163,15 @@
 
 
-static pj_status_t pjsip_tsx_on_state_destroyed(pjsip_transaction *tsx,
-                                                pjsip_event *event)
+/*
+ * Handler for events in state Destroyed.
+ * Shouldn't happen!
+ */
+static pj_status_t tsx_on_state_destroyed(pjsip_transaction *tsx,
+                                          pjsip_event *event)
 {
     PJ_UNUSED_ARG(tsx);
     PJ_UNUSED_ARG(event);
-    return PJ_SUCCESS;
-}
-
+    pj_assert(!"Not expecting any events!!");
+    return PJ_EBUG;
+}
+
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 107)
@@ -71,5 +71,7 @@
     { PJSIP_TRANSPORT_TCP, 5060, {"TCP", 3}, PJSIP_TRANSPORT_RELIABLE},
     { PJSIP_TRANSPORT_TLS, 5061, {"TLS", 3}, PJSIP_TRANSPORT_RELIABLE | PJSIP_TRANSPORT_SECURE},
-    { PJSIP_TRANSPORT_SCTP, 5060, {"SCTP", 4}, PJSIP_TRANSPORT_RELIABLE}
+    { PJSIP_TRANSPORT_SCTP, 5060, {"SCTP", 4}, PJSIP_TRANSPORT_RELIABLE},
+    { PJSIP_TRANSPORT_LOOP, 15060, {"LOOP", 4}, PJSIP_TRANSPORT_RELIABLE}, 
+    { PJSIP_TRANSPORT_LOOP_DGRAM, 15060, {"LOOP-DGRAM", 10}, PJSIP_TRANSPORT_DATAGRAM},
 };
 
@@ -195,5 +197,5 @@
     status = pj_atomic_create(tdata->pool, 0, &tdata->ref_cnt);
     if (status != PJ_SUCCESS) {
-	pjsip_endpt_destroy_pool( mgr->endpt, tdata->pool );
+	pjsip_endpt_release_pool( mgr->endpt, tdata->pool );
 	return status;
     }
@@ -202,5 +204,5 @@
     status = pj_lock_create_null_mutex(pool, "tdta%p", &tdata->lock);
     if (status != PJ_SUCCESS) {
-	pjsip_endpt_destroy_pool( mgr->endpt, tdata->pool );
+	pjsip_endpt_release_pool( mgr->endpt, tdata->pool );
 	return status;
     }
@@ -239,5 +241,5 @@
 	pj_atomic_destroy( tdata->ref_cnt );
 	pj_lock_destroy( tdata->lock );
-	pjsip_endpt_destroy_pool( tdata->mgr->endpt, tdata->pool );
+	pjsip_endpt_release_pool( tdata->mgr->endpt, tdata->pool );
 	return PJSIP_EBUFDESTROYED;
     } else {
@@ -716,14 +718,8 @@
 	}
 
-	/* If message is received from address that's different from sent-by,
-  	 * MUST add received parameter to the via.
-	 */
-	if (pj_strcmp2(&rdata->msg_info.via->sent_by.host, 
-		       rdata->pkt_info.src_name) != 0) 
-	{
-	    pj_strdup2(rdata->tp_info.pool, 
-		       &rdata->msg_info.via->recvd_param, 
-		       rdata->pkt_info.src_name);
-	}
+	/* Always add received parameter to the via. */
+	pj_strdup2(rdata->tp_info.pool, 
+		   &rdata->msg_info.via->recvd_param, 
+		   rdata->pkt_info.src_name);
 
 	/* RFC 3581:
